#ifdef SOUND_H
#error "multiple include"
#endif
#define SOUND_H

void sound_init(void);
void sound_stop(void);
void sound_start(void);
void sound_update(void);
void sound_play(int sample);
void sound_restartmusic(void);
void sound_nextmusic(void);
void sound_playtitlemusic(void);

enum
{
	SMP_SHOOT,        /* Train shoots */
	SMP_KILL,         /* Monster dies */
	SMP_DISINTEGRATE, /* Bullet hits tracks, disintegrates */
	SMP_TELEPORT,     /* Train teleports */
	SMP_TIMEUP,       /* You took too long */
	SMP_REFLECT,      /* Train bounces */
	NUMSAMPLES
};
